Loading...
Searching...
No Matches
Dfs< GR, TR > Class Template Reference
Algorithms » Graph Search

## Detailed Description

template<typename GR, typename TR>
class lemon::Dfs< GR, TR >

This class provides an efficient implementation of the DFS algorithm.

There is also a function-type interface for the DFS algorithm, which is convenient in the simplier cases and it can be used easier.

Template Parameters

  GR | The type of the digraph the algorithm runs on. The default type is ListDigraph.
  TR | The traits class that defines various types used by the algorithm. By default, it is DfsDefaultTraits<GR>. In most cases, this parameter should not be set directly, consider to use the named template parameters instead.

`#include <lemon/dfs.h>`

## Classes

struct | SetPredMap
| Named parameter for setting More...
struct | SetDistMap
| Named parameter for setting More...
struct | SetReachedMap
| Named parameter for setting More...
struct | SetProcessedMap
| Named parameter for setting More...
struct | SetStandardProcessedMap
| Named parameter for setting More...

## Public Types

typedef TR::Digraph | Digraph
| The type of the digraph the algorithm runs on.
typedef TR::PredMap | PredMap
| The type of the map that stores the predecessor arcs of the DFS paths.
typedef TR::DistMap | DistMap
| The type of the map that stores the distances of the nodes.
typedef TR::ReachedMap | ReachedMap
| The type of the map that indicates which nodes are reached.
typedef TR::ProcessedMap | ProcessedMap
| The type of the map that indicates which nodes are processed.
typedef PredMapPath< Digraph, PredMap > | Path
| The type of the paths.
typedef TR | Traits
| The traits class of the algorithm.

## Public Member Functions

| Dfs (const Digraph &g)
| Constructor.
| ~Dfs ()
| Destructor.
Dfs & | predMap (PredMap &m)
| Sets the map that stores the predecessor arcs.
Dfs & | reachedMap (ReachedMap &m)
| Sets the map that indicates which nodes are reached.
Dfs & | processedMap (ProcessedMap &m)
| Sets the map that indicates which nodes are processed.
Dfs & | distMap (DistMap &m)
| Sets the map that stores the distances of the nodes.
Execution Control
The simplest way to execute the DFS algorithm is to use one of the member functions called run(). If you need better control on the execution, you have to call
void | init ()
| Initializes the internal data structures.
void | addSource (Node s)
| Adds a new source node.
Arc | processNextArc ()
| Processes the next arc.
OutArcIt | nextArc () const
| Next arc to be processed.
bool | emptyQueue () const
| Returns `false` if there are nodes to be processed.
int | queueSize () const
| Returns the number of the nodes to be processed.
void | start ()
| Executes the algorithm.
void | start (Node t)
| Executes the algorithm until the given target node is reached.
template<class ArcBoolMap>
Arc | start (const ArcBoolMap &am)
| Executes the algorithm until a condition is met.
void | run (Node s)
| Runs the algorithm from the given source node.
bool | run (Node s, Node t)
| Finds the DFS path between `s` and `t`.
void | run ()
| Runs the algorithm to visit all nodes in the digraph.
Query Functions
The results of the DFS algorithm can be obtained using these functions. Either run() or start() should be called before using them.
Path | path (Node t) const
| The DFS path to the given node.
int | dist (Node v) const
| The distance of the given node from the root(s).
Arc | predArc (Node v) const
| Returns the 'previous arc' of the DFS tree for the given node.
Node | predNode (Node v) const
| Returns the 'previous node' of the DFS tree for the given node.
const DistMap & | distMap () const
| Returns a const reference to the node map that stores the distances of the nodes.
const PredMap & | predMap () const
| Returns a const reference to the node map that stores the predecessor arcs.
bool | reached (Node v) const
| Checks if the given node. node is reached from the root(s).

## Constructor & Destructor Documentation

## Dfs()

template<typename GR, typename TR>

Dfs | ( | const Digraph & | g | ) |

inline

Constructor.

Parameters

  g | The digraph the algorithm runs on.

## Member Function Documentation

## predMap() [1/2]

template<typename GR, typename TR>

Dfs & predMap | ( | PredMap & | m | ) |

inline

Sets the map that stores the predecessor arcs. If you don't use this function before calling run() or init(), an instance will be allocated automatically. The destructor deallocates this automatically allocated map, of course.

Returns
  (*this)

## reachedMap()

template<typename GR, typename TR>

Dfs & reachedMap | ( | ReachedMap & | m | ) |

inline

Sets the map that indicates which nodes are reached. If you don't use this function before calling run() or init(), an instance will be allocated automatically. The destructor deallocates this automatically allocated map, of course.

Returns
  (*this)

## processedMap()

template<typename GR, typename TR>

Dfs & processedMap | ( | ProcessedMap & | m | ) |

inline

Sets the map that indicates which nodes are processed. If you don't use this function before calling run() or init(), an instance will be allocated automatically. The destructor deallocates this automatically allocated map, of course.

Returns
  (*this)

## distMap() [1/2]

template<typename GR, typename TR>

Dfs & distMap | ( | DistMap & | m | ) |

inline

Sets the map that stores the distances of the nodes calculated by the algorithm. If you don't use this function before calling run() or init(), an instance will be allocated automatically. The destructor deallocates this automatically allocated map, of course.

Returns
  (*this)

## init()

template<typename GR, typename TR>

void init | ( |  | ) |

inline

init() first, then you can add a source node with addSource() and perform the actual computation with start(). This procedure can be repeated if there are nodes that have not been reached.

Initializes the internal data structures.

## addSource()

template<typename GR, typename TR>

void addSource | ( | Node | s | ) |

inline

Adds a new source node to the set of nodes to be processed.

Precondition
  The stack must be empty. Otherwise the algorithm gives wrong results. (One of the outgoing arcs of all the source nodes except for the last one will not be visited and distances will also be wrong.)

## processNextArc()

template<typename GR, typename TR>

Arc processNextArc | ( |  | ) |

inline

Processes the next arc.

Returns
  The processed arc.

Precondition
  The stack must not be empty.

## nextArc()

template<typename GR, typename TR>

OutArcIt nextArc | ( |  | ) | const

inline

Next arc to be processed.

Returns
  The next arc to be processed or `INVALID` if the stack is empty.

## emptyQueue()

template<typename GR, typename TR>

bool emptyQueue | ( |  | ) | const

inline

Returns `false` if there are nodes to be processed in the queue (stack).

## queueSize()

template<typename GR, typename TR>

int queueSize | ( |  | ) | const

inline

Returns the number of the nodes to be processed in the queue (stack).

## start() [1/3]

template<typename GR, typename TR>

void start | ( |  | ) |

inline

Executes the algorithm.

This method runs the DFS algorithm from the root node in order to compute the DFS path to each node.

The algorithm computes

- the DFS tree,
- the distance of each node from the root in the DFS tree.
  Precondition
    init() must be called and a root node should be added with addSource() before using this function.
  Note
    d.start() is just a shortcut of the following code.
    while ( !d.emptyQueue() ) {
    d.processNextArc();
    }

## start() [2/3]

template<typename GR, typename TR>

void start | ( | Node | t | ) |

inline

Executes the algorithm until the given target node is reached.

This method runs the DFS algorithm from the root node in order to compute the DFS path to `t`.

The algorithm computes

- the DFS path to `t`,
- the distance of `t` from the root in the DFS tree.
  Precondition
    init() must be called and a root node should be added with addSource() before using this function.

## start() [3/3]

template<typename GR, typename TR>
template<class ArcBoolMap>

Arc start | ( | const ArcBoolMap & | am | ) |

inline

Executes the algorithm until a condition is met.

This method runs the DFS algorithm from the root node until an arc `a` with am[a] true is found.

Parameters

  am | A `bool` (or convertible) arc map. The algorithm will stop when it reaches an arc `a` with am[a] true.

Returns
  The reached arc `a` with am[a] true or `INVALID` if no such arc was found.

Precondition
  init() must be called and a root node should be added with addSource() before using this function.

Warning
  Contrary to Bfs and Dijkstra, `am` is an arc map, not a node map.

## run() [1/3]

template<typename GR, typename TR>

void run | ( | Node | s | ) |

inline

This method runs the DFS algorithm from node `s` in order to compute the DFS path to each node.

The algorithm computes

- the DFS tree,
- the distance of each node from the root in the DFS tree.
  Note
    d.run(s) is just a shortcut of the following code.
    d.init();
    d.addSource(s);
    d.start();

## run() [2/3]

template<typename GR, typename TR>

bool run | ( | Node | s,
|  | Node | t )

inline

This method runs the DFS algorithm from node `s` in order to compute the DFS path to node `t` (it stops searching when `t` is processed)

Returns
  `true` if `t` is reachable form `s`.

Note
  Apart from the return value, d.run(s,t) is just a shortcut of the following code.
  d.init();
  d.addSource(s);
  d.start(t);

## run() [3/3]

template<typename GR, typename TR>

void run | ( |  | ) |

inline

This method runs the DFS algorithm in order to visit all nodes in the digraph.

Note
  d.run() is just a shortcut of the following code.
  d.init();
  for (NodeIt n(digraph); n != INVALID; ++n) {
  if (!d.reached(n)) {
  d.addSource(n);
  d.start();
  }
  }
  lemon::INVALID
  const Invalid INVALID
  Invalid iterators.
  Definition base.cc:32

## path()

template<typename GR, typename TR>

Path path | ( | Node | t | ) | const

inline

Returns the DFS path to the given node from the root(s).

Warning
  `t` should be reached from the root(s).

Precondition
  Either run() or init() must be called before using this function.

## dist()

template<typename GR, typename TR>

int dist | ( | Node | v | ) | const

inline

Returns the distance of the given node from the root(s).

Warning
  If node `v` is not reached from the root(s), then the return value of this function is undefined.

Precondition
  Either run() or init() must be called before using this function.

## predArc()

template<typename GR, typename TR>

Arc predArc | ( | Node | v | ) | const

inline

This function returns the 'previous arc' of the DFS tree for the node `v`, i.e. it returns the last arc of a DFS path from a root to `v`. It is `INVALID` if `v` is not reached from the root(s) or if `v` is a root.

The DFS tree used here is equal to the DFS tree used in predNode() and predMap().

Precondition
  Either run() or init() must be called before using this function.

## predNode()

template<typename GR, typename TR>

Node predNode | ( | Node | v | ) | const

inline

This function returns the 'previous node' of the DFS tree for the node `v`, i.e. it returns the last but one node of a DFS path from a root to `v`. It is `INVALID` if `v` is not reached from the root(s) or if `v` is a root.

The DFS tree used here is equal to the DFS tree used in predArc() and predMap().

Precondition
  Either run() or init() must be called before using this function.

## distMap() [2/2]

template<typename GR, typename TR>

const DistMap & distMap | ( |  | ) | const

inline

Returns a const reference to the node map that stores the distances of the nodes calculated by the algorithm.

Precondition
  Either run() or init() must be called before using this function.

## predMap() [2/2]

template<typename GR, typename TR>

const PredMap & predMap | ( |  | ) | const

inline

Returns a const reference to the node map that stores the predecessor arcs, which form the DFS tree (forest).

Precondition
  Either run() or init() must be called before using this function.

## reached()

template<typename GR, typename TR>

bool reached | ( | Node | v | ) | const

inline

Returns `true` if `v` is reached from the root(s).

Precondition
  Either run() or init() must be called before using this function.